/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.ergebnis;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.ergebnis.boundary.AbstractErgebnisLogEintragSearchParameters;
import de.ivu.elect.business.ergebnis.boundary.ErgebnisLogEintragChangeEvent;
import de.ivu.elect.business.ergebnis.boundary.ErgebnisLogEintragConversationStore;
import de.ivu.elect.business.ergebnis.boundary.ErgebnisLogEintragExtendedDAO;
import de.ivu.elect.business.ergebnis.boundary.ErgebnisLogEintragSearch;
import de.ivu.elect.business.ergebnis.boundary.ErgebnisLogEintragSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.ergebnis.entity.ErgebnisLogEintrag;
import de.ivu.elect.business.ergebnis.entity.ErgebnisLogEintragMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractErgebnisLogEintragSearchView.COMPONENT_NAME)
@View(viewId = AbstractErgebnisLogEintragSearchView.VIEW_ID, useCase = UseCasePermission.ERGEBNIS_LOG_EINTRAG_SEARCH)
public abstract class AbstractErgebnisLogEintragSearchView extends AbstractElectSearchView<ErgebnisLogEintrag> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "ergebnisLogEintragSearchView";
  
  public static final String VIEW_ID = "/ergebnis/ergebnis-log-eintrag-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractErgebnisLogEintragSearchView requestHandler;

  @Inject
  private transient ErgebnisLogEintragExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(ErgebnisLogEintragConversationStore.class)
  protected transient ErgebnisLogEintragConversationStore conversationStore;

  @Inject
  protected transient ErgebnisLogEintragSearch search;

  @Inject
  @ConversationGroup(AbstractErgebnisLogEintragSearchParameters.class)
  protected transient ErgebnisLogEintragSearchParameters searchParameters;

  @Inject
  protected transient ErgebnisLogEintragMeta entityMeta;

  public AbstractErgebnisLogEintragSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public ErgebnisLogEintrag getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(ErgebnisLogEintrag entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public ErgebnisLogEintragSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<ErgebnisLogEintrag> getEagerLoadingCollector() {
    return EagerLoadingCollector.<ErgebnisLogEintrag> create();
  }

  @Override
  public List<ErgebnisLogEintrag> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<ErgebnisLogEintrag> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onErgebnisLogEintragChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) ErgebnisLogEintragChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractErgebnisLogEintragSearchView {

    @View
    @Inject
    private transient Instance<AbstractErgebnisLogEintragSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractErgebnisLogEintragSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
